"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }// src/index.ts
var _argon2umdminjs = require('hash-wasm/dist/argon2.umd.min.js');
var _randombytes = require('randombytes'); var _randombytes2 = _interopRequireDefault(_randombytes);
var _tschacha20 = require('ts-chacha20');
async function argon2({ password, salt }) {
  const result = await _argon2umdminjs.argon2d.call(void 0, {
    password,
    salt,
    parallelism: 1,
    iterations: 2,
    memorySize: 32,
    hashLength: 32,
    outputType: "hex"
  });
  return Buffer.from(result, "hex");
}
function generateRandom(length = 16) {
  return Uint8Array.from(_randombytes2.default.call(void 0, length));
}
async function encrypt(data, password) {
  const salt = generateRandom(12);
  const key = await argon2({ password, salt });
  const encrypt2 = new (0, _tschacha20.Chacha20)(key, salt).encrypt(Buffer.from(data, "utf8"));
  const packaged = Buffer.from([...salt, ...encrypt2]);
  return packaged.toString("base64");
}
async function decrypt(data, password) {
  const unpackaged = Buffer.from(data, "base64");
  const salt = unpackaged.subarray(0, 12);
  const input = unpackaged.subarray(12, data.length);
  const key = await argon2({ password, salt });
  const message = new (0, _tschacha20.Chacha20)(key, salt).decrypt(input);
  return Buffer.from(message).toString("utf8");
}




exports.argon2 = argon2; exports.decrypt = decrypt; exports.encrypt = encrypt;
